class List{
    private final static List NIL=null;
    private int head;
    private List tail;
    private List(int head,List tail){
        this.head=head; this.tail=tail;
    }
    public static List cons(int head,List tail){
        return new List(head,tail);
    }
    public static List nil(){
        return NIL;
    }
    public static boolean isNil(List l){
        return l==NIL;
    }
    public static int getHead(List l){
        return l.head;
    }
    public static List getTail(List l){
        return l.tail;
    }
    
    /*      isEqual: List x List -> boolean
            isEqual(nil,nil)=true
            isEqual(nil,cons(I,L))=false
            isEqual(cons(I,L),nil)=false
            isEqual(cons(I,L),cons(J,M))=false when I!=J
            isEqual(cons(I,L),cons(I,M))=isEqual(L,M)   */
            
    public static boolean isEqual(List l1,List l2){
        if (isNil(l1) && isNil(l2)) {
            return true;
        } else if (!isNil(l1) ^ !isNil(l2)) {
            return false;
        } else if(getHead(l1)!=getHead(l2)) {
            return false;
        }
        return isEqual(getTail(l1),getTail(l2));
    }
    
    /*      toString: List -> String
            toString(l)="("+toString2(l)+")"
            
            toString2: List -> String
            toString2(nil)=""
            toString2(cons(I,nil))=""+I
            toString2(cons(I,cons(J,L)))=""+I+","+toString2(cons(J,L))
            */
    
    
    public static String toString (List l){
        return "("+toString2(l)+")";
    }
    
    private static String toString2(List l){
        if (isNil(l)){
            return "";
        } else if (isNil(getTail(l))){
            return ""+getHead(l);
        } else {
            return ""+getHead(l)+","+toString2(getTail(l));
        }
    }
    
    public static List fromArray(int[] a){
        List l=nil();
        for (int i=a.length-1;i>=0;i--){
            l=cons(a[i],l);
        }
        return l;
    }
    
}
